# Friendly URLs

## Make it work

* Clone the repository.
* Open folder with VSCode.
* Right click and Run `src > main > java > ... > Main.java`.
* Open [http://localhost:8080](http://localhost:8080) in the browser.

## Objective

Many frameworks or applications allow using clean URLs. But, what is the diference between *clean* and *unclean* URLs?

* **Unclean URL**: [http://localhost:8080/user?aciton=edit&id=1](http://localhost:8080/user?aciton=edit&id=1)
* **Clean URL**: [http://localhost:8080/user/1/edit](http://localhost:8080/user/1/edit)

You can see that in clean URLs some parameters are included inside the path (e.g. *user_id* is the 2nd level of the path and *action* is the 3rd level of the path). Those are usually called path parameters. Java servlet do not allow getting those parameters automatically, but you can do it yourself.

Another objective of this appliction is **not to call any JSP file directly**, everything should pass through a controller. That gives us more controll (e.g. Check if the user is in the session before sending them the HTML). So we have to do something also to make the root URL to execute a controller before calling ```index.jsp```.

The last objective is to learn how to use **Filters**. They allow us to filter user's permissions before accessing to controllers. This way, we can extract authorization logic from controllers, making them easier to understand and maintain.

## Explaination

We will explain what we did in this project to fulfill the objectives.

### Index controller

We will start from the root path (```/```): how do we make to call a controller when we enter [http://localhost:8080](http://localhost:8080) ?

We can create a controller (IndexController) that listens to ```index.html``` path. ```index.html``` is the first file the server looks for when accessing to the root path, so we make the controller to responde to that path.

```java
// IndexController.java
...
@WebServlet( name = "IndexController", urlPatterns = {"/index.html"})
public class IndexController extends HttpServlet {
  ...
```

**WARNING! Do not use "/" as the urlPattern or the controller will always be called (even if we are accessing to ```/css/style.css```)**

Now that we know how to call to **IndexController** with the "root" path, will dispatch ```home.jsp```:

```java
//IndexController.java
...
protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
  System.out.println("Index Controller");
  RequestDispatcher dispatcher = getServletContext()
    .getRequestDispatcher("/WEB-INF/view/home.jsp");
  dispatcher.forward(request, response);
}
...
```

So calling [http://localhost:8080](http://localhost:8080) will return the HTML generated by ```home.jsp```. 

### Home.jsp

```home.jsp``` has 7 links:

* 'emtpy' that will make a get to ```/friendly```.
* '/' that will make a get to ```/friendly/```.
* 'Just action' that will make a get to ```/friendly/create```.
* 'Just id' that will make a get to ```/friendly/1```.
* 'Id `action' that will make a get to ```/friendly/1/edit```.
* 'Access home.jsp' that will try to access ```home.jsp``` directly.
* 'filter-me' that will make a get to ```/friendly/1/filter-me```.

In order to response to the first 5 links, the urlPattern of **FriendlyController** is ```/friendly/*```:

```java
//FriendlyController.java
...
@WebServlet(name = "FriendlyController", urlPatterns = { "/friendly/*" })
...
```

As there is no way to get the path parameters automatically, we have created a ```ControllerHelper``` that will extract the action and id from the URL (it will be explained in detail in the next section).

6th link should return a 404, because ```home.jsp``` is inside ```WEB-INF``` folder, and there should be no access to that folder directrly from the browser.

7th link will execute a filter (ExampleFilter) and will redirect the user to an error page.

### Controller Helper

When ```FriendlyController``` is called, the 1st thing it will do is calling ControllerHelper and get the path parameters.

```java
// FriendlyController.java
...
ControllerHelper controllerHelper = new ControllerHelper(request);
int id = controllerHelper.getId();
String action = controllerHelper.getAction();
...
```

```ControllerHelper``` will analyze the path of the request. It will consider 3 options:

* Only one level in the path: ```x/``` or ```x```
  * will return default action (```list```) and id (```-1```).
  * Example: ```/user``` would be called to list all the users in the database.
* 2 levels in the path: ```x/y```
  * If ```y``` is an integer, it will be the id and the action will be ```view```.
    * Example: ```/news_item/1```, **1** would be the ID of the news_item and ```view``` the action. this could be used to view a specific news item.
  * If ```y``` is a string, it will be the action and the id will be ```-1```.
    * Example: ```/user/create```, there wouldn't be any ID and ```create``` would be the action. This could be the path to create a new user.
* 3 levels in the path: ```x/y/z```
  * ```y``` must be an integer and it will be the id.
  * ```z``` must be a string and it will be the action.
  * Example: ```/user/3/delete```, 3 will be the ID and ```delete``` the action. This could be tha path for deleting a specific user.

Analyze ```ControllerHelper``` and ask any question if there are doubts.

Usually, a ```FriendlyController``` would execute different functions depending on the action, in this case we only will print them on the view.

### Filters

We can create filters to avoid controller execution in certain situations. For example, we can check if the user is authorized to perform the action.

We could also do that in the controller, but filters allow us to separate that logic and keep controller shorter and easier to read an maintain.

As an example, we have createrd the ```ExampleFilter```. We have defined that is always executed before any request(```"/*"```):

```java
@WebFilter("/*")
public class ExampleFilter implements Filter {
  ...
```

It's **Constructor**, **destroy** and **init** methods are empty (we could add something if needed). The key functionality comes in the ```doFilter``` function. In this case, it gets the path from the request and if it contains the **filter-me** string, it will redirect to an error page (no controller will be executed):

```java
// ExampleFilter.java
...
String requestPath = request.getRequestURI();
...
if (requestPath.contains("filter-me")) {
  ...
  response.sendRedirect("error");
}
...
```

If that string is not in the path, the normal execution will continue as follows:

```java
// ExampleFilter.java
...
chain.doFilter(req, res);
...
```

### JSP filter

You could create a filter that checked if the user was trying to access a JSP file directrly with ```requestPath.endsWith(".jsp")```.

But notice that WEB-INF folder can be used for that, making it much easier and without needing a Filter class. You can store the jsp files in ```WEB-INF/view folder``` and that way the filter is not needed.

This would also allow us to give access to some jsp files (putting them outside WEB-INF folder) and denny access to other ones (putting them inside WEB-INF folder).

In our case we will always use a controller to access any view and we will never call a jsp file directly. So none of our URLs will ned with ```.jsp```.

What are the main advantages?

* This makes more complicated to identify which technology we are using (for example to potential hackers).
* This allows us to change the technology in the future maintaining the urls. So you would not pass from "https://mypage.com/user.jsp" to "https://mypage.com/user.asp" if you change the technology. That way, if you have any external page linked to your app, it will not break.
* You can control or log any access to a view with Filters or Controllers. For example, to make statistics on which are the most visited views etc.

## Exercise

Now, you should take MVC-Exercise 1 and add clean URLs and filters to it:

This is what you have to do:

* Create a new project taking the code from mvc-exercise-1 as a base (call it mvc-exercise-2 for example).
* No jsp should be directly accessible.
* Use a **new filter class** to manage permissions for user actions.
  * Anyone can create a User.
  * Only logged users can **view**, **list**, **edit** or **delete** users.
  * Moreover, users can only **edit** and **delete** their own user.
* Modify UserController so the URLs are clean now:
  * ```GET /user``` & ```/GET /user/list``` should do the same: Dispatch ```user_list.jsp``` that will show the list of all users.
* ```GET /user/{id}``` should dispatch ```user.jsp``` showing a specific user's data.
  * ```GET /user/create``` should dispatch ```user_form.jsp``` (empty).
  * ```POST /user/create``` should store user in DB and redirect to ```/user/{id}```.
  * ```GET /user/{id}/edit``` should dispatch ```user_form.jsp``` filled with user's data.
  * ```POST /user/{id}/edit``` should update user in DB and redirect to ```/user/{id}```.
  * ```GET /user/{id}/delete``` should delete user from DB and redirect to ```/user```.
* User list should only show edit and delete actions for the user in the session.
* Navigation should not show user list if there is not a user in the session.

## Before

* Before [11-dao-user](https://gitlab.com/mgep-web-engineering-1/javaee/11-dao-user)